/*********************************************************************************

	SC02 ݃vO	RTSPgp Ver.1.1
	
													2015.7.28 M.Utsumi@ARCDEVICE 

**********************************************************************************/


#include<windows.h>
#include<stdio.h>
#include<conio.h>
#include<string.h>
#include "SC02_Boot.h"

#define sscanf sscanf_s
#define strcpy strcpy_s
//#define fscanf fscanf_s

#define MAX_CODE_SIZE		0x10000 // 16k word
#define DATA_EEPROM_SIZE	0x1000 // 1k byte


#define RTSP_CONNECT	20
#define RTSP_ERASE		21
#define RTSP_WRITE		22
#define RTSP_READ		23
#define RTSP_RUN		24
#define RTSP_TEST		25

SC02_Boot ScDevice;

void PrintData( BYTE* pbData, int size )
{
	int i;

	i=0;
	while(size--){
        printf( "%02x ", *pbData++ );
		if(++i==16){
			printf("\n");
			i=0;
		}
	}
	printf("\n");
}

void PrintCode( WORD* pwCode, DWORD dwSize )
{
	WORD wCode_l, wCode_h;

	while(dwSize-=2){
		wCode_l = *pwCode++;
		wCode_h = *pwCode++;
        printf( "%04x %04x \n", wCode_h, wCode_l );
	}
	printf("\n");
}


BYTE get_b( char** pStr  )
{
	char buf[3];
	int i;

	buf[0] = *(*pStr)++;
	buf[1] = *(*pStr)++;
	buf[2] = '\0';
	sscanf( buf, "%x", &i );
	return( (BYTE) i );
}

WORD get_w( char** pStr  )
{
	char buf[5];
	int i;

	buf[0] = *(*pStr)++;
	buf[1] = *(*pStr)++;
	buf[2] = *(*pStr)++;
	buf[3] = *(*pStr)++;
	buf[4] = '\0';
	sscanf( buf, "%x", &i );

	return( (WORD)i );
}

WORD get_code( char** pStr  )
{
	char buf[5];
	int i;

	// MSB <-> LSB
	buf[2] = *(*pStr)++;
	buf[3] = *(*pStr)++;
	buf[0] = *(*pStr)++;
	buf[1] = *(*pStr)++;
	buf[4] = '\0';

	sscanf( buf, "%x", &i );
	return( (WORD)i );
}



DWORD ConvertIntelHexFormat( FILE* fp, WORD* pwCode )
{
	BOOL loop;
	char buf[256], *str;
	int length, type, i;
	union {
		DWORD dwLine;
		struct{
        WORD wOffset;
		WORD wSegment;
		} _16;
	} Addr;
	DWORD dwSize;

	loop = TRUE;
	dwSize = 0;
	Addr.dwLine = 0;
    
	do{
		str = buf;
		fscanf_s( fp,"%s", str, 256 );
        
		if( *str++ != ':' ){
			printf("Error:Illigal file format!!\n");
			fflush(stdout);
			return( -1 );
		}
		length = get_b( &str );
		Addr._16.wOffset = get_w( &str ) >> 1;
        type = get_b( &str );
    	
		switch( type ){
		case 0x00:	// Data record
            for(i=0;i<length/4;i++){
				if( Addr.dwLine < MAX_CODE_SIZE ){
					// read 1 instruction( 2 words )
					pwCode[Addr.dwLine++] = get_code( &str ); // low
					pwCode[Addr.dwLine++] = 0x00FF & get_code( &str ); // high
					//printf("%08x:%04x%04x\n",addr.lin, code[addr.lin-1], code[addr.lin-2] );
					if( dwSize < Addr.dwLine ) dwSize = Addr.dwLine;
				}
			}
			break;
		case 0x01:	// End record
			loop = FALSE;
			break;
		case 0x02:	// Segment address record
			break;
		case 0x03: 	// Start Segment address record
			break;
		case 0x04:	// Extended linear address record
			Addr._16.wSegment = get_w( &str );
			break;
		case 0x05:	// Start linear address record
			break;
		default:
			printf("Error:unknown code\n");
			fflush(stdout);
			return( -1 );
		}
	}while(loop);

	return( dwSize );
}


BOOL EraseCode( WORD wSize )
{
	WORD wAddr, wEraseNum, w;
	BYTE bRet;
	int p;

	wAddr = 0;
	wEraseNum = (wSize+63) / 64;
	p = wEraseNum/10+1;

	for( w=0; w<wEraseNum; w++ ){
		if(!ScDevice.putb( RTSP_ERASE ) ) return( FALSE );
		if(!ScDevice.putw(wAddr)) return( FALSE );
		if(!ScDevice.getb( &bRet )) return( FALSE );
		if( bRet!='a' )	return( FALSE );
		wAddr+=64;

		if( (w+1)%p == 0 ){
			putchar('*');
			fflush(stdout);
		}
	}
	putchar(' ');
	fflush(stdout);

	return( TRUE );
}


BOOL WriteCode( WORD* pwCode, WORD wSize )
{
	WORD w, wAddr, wPacketNum, wRemainCode, wByteSize;
	BYTE bRet;
	int p;

	wByteSize = (wSize + 7)/8*8;
	wPacketNum = wByteSize / 128; // 1 paket = 128 words
	wRemainCode = wByteSize % 128;
	//printf("size = %d s8=%d words  %d packets %d code_remain \n", size, size_8, packet_num, code_remain );
	wAddr = 0;
	p = wPacketNum/10+1;

	for(w=0;w<wPacketNum;w++){
		if(!ScDevice.putb( RTSP_WRITE )) return( FALSE );
		if(!ScDevice.putw( wAddr)) return( FALSE );
		if(!ScDevice.putw( 128 )) return( FALSE );
		if(!ScDevice.getb( &bRet )) return( FALSE );
		if( bRet!='a' )	return( FALSE );
		
		if(!ScDevice.Write( (BYTE*)pwCode, 128*2 ) ) return( FALSE );  // byte size
		pwCode+=128;
		wAddr+=128;
		if(!ScDevice.getb( &bRet )) return( FALSE );
		if( bRet!='a' )	return( FALSE );

		if( (w+1)%p == 0 ){
			putchar('*');
			fflush(stdout);
		}
	}
	if( wRemainCode!=0){
		if(!ScDevice.putb( RTSP_WRITE )) return( FALSE );
		if(!ScDevice.putw( wAddr )) return( FALSE );
		if(!ScDevice.putw( wRemainCode )) return( FALSE );
		if(!ScDevice.getb( &bRet )) return( FALSE );
		if( bRet!='a' )	return( FALSE );
	
		if(!ScDevice.Write( (BYTE*)pwCode, wRemainCode*2 )) return( FALSE ); // byte size
		if(!ScDevice.getb( &bRet )) return( FALSE );
		if( bRet!='a' )	return( FALSE );

		putchar('*');
		fflush(stdout);
	}

	putchar(' ');
	fflush(stdout);
	
	return( TRUE );
}


BOOL ReadCode( WORD* pwCode, WORD wSize )
{
	WORD w, wPacketNum, wRemainCode, wSize_2, wAddr;
	BYTE bRet;
	int p;

	wSize_2 = (wSize+1)/2*2;
	wPacketNum = wSize_2 / 128; // 1 paket = 128 words
	wRemainCode = wSize_2 % 128;
	//printf("size = %d s2 %d words  %d packets %d code_remain \n", size, size_2, packet_num, code_remain );
	wAddr = 0;
	p = wPacketNum/10+1;

	for(w=0;w<wPacketNum;w++){
		if(!ScDevice.putb( RTSP_READ )) return( FALSE );
		if(!ScDevice.putw( wAddr )) return( FALSE );
		if(!ScDevice.putw( 128 )) return( FALSE );
		if(!ScDevice.Read( (BYTE*)pwCode, 128*2 ))	return( FALSE );
		
		pwCode+=128;
		wAddr+=128;
		if(!ScDevice.getb( &bRet )) return( FALSE );
		if(  bRet!='a' )	return( FALSE );

		if( (w+1)%p == 0 ){
			putchar('*');
			fflush(stdout);
		}
	}
	if( wRemainCode!=0){
		if(!ScDevice.putb( RTSP_READ )) return( FALSE );
		if(!ScDevice.putw( wAddr )) return( FALSE );
		if(!ScDevice.putw( wRemainCode )) return( FALSE );
		if(!ScDevice.Read( (BYTE*)pwCode, wRemainCode*2 ))	return( FALSE );
		
		if(!ScDevice.getb( &bRet )) return( FALSE );
		if(  bRet!='a' )	return( FALSE );

		putchar('*');
		fflush(stdout);
	}

	putchar(' ');
	fflush(stdout);

	return( TRUE );
}

BOOL VerifyingCode( WORD* pwCode, WORD* pwCode_v, WORD wSize )
{
	WORD w;
	int p;

	p = wSize/10+1;

	for(w=0;w<wSize;w++){
	//	printf( "addr %04x code %04x %04x \n", i, code[i], code_v[i] );
		if( pwCode[w] != pwCode_v[w] ){
			printf("\nError:code miss match in address %04x\n", w );
			fflush(stdout);
			return( FALSE );
		}

		if( (w+1)%p == 0 ){
			putchar('*');
			fflush(stdout);
		}
	}

	putchar(' ');
	fflush(stdout);

	return( TRUE );
}

int main( int argc, char* argv[] )
{
	FILE* fp;
	char* name;
	char test_file[] = "..\\blink\\Ex.hex";
// 	char test_file[] = "..\\dsPIC_MCD05\\Ex.hex";
    int i; 
	WORD wSize;
	WORD wCode[MAX_CODE_SIZE];			
	WORD wCode_v[MAX_CODE_SIZE];			
	BYTE bID, bChildID, bMode;

	printf("SC02 Programmer Version 1.1 by ARCDEVICE\n");
	fflush(stdout);

	// Data Initialize
	for(i=0;i<MAX_CODE_SIZE;i+=2){
		wCode[i]=0xFFFF;
		wCode[i+1]=0x00FF;
		wCode_v[i]=0xFFFF;
		wCode_v[i+1]=0x00FF;
	}

	bID = CM_MASTER_ID;
	bChildID = CM_MASTER_ID;
	bMode ='p';	// Programmer Mode
//	bMode ='w';	// Writer Mode
	
	switch( argc){
	case 1:
		name = test_file ;
		break;
	case 2:
		bMode = *argv[1];
	case 3:
		bMode = *argv[1];
		name = argv[2];
		break;
	case 4:
		bMode = *argv[1];
		name = argv[2];
		bID = atoi( argv[3] );
		break;
	case 5:
		bMode = *argv[1];
		name = argv[2];
		bID = atoi( argv[3] );
		bChildID = atoi( argv[4] );
		break;
	default:
		printf("Error:argument exceed\n");
		return(0 );
	}

// Check
	switch( bMode ){
	case 'p': bMode = CM_PROGRAMING_MODE; break;
	case 'w': bMode = CM_WRITER_MODE; break;
	default : printf("Error:unknown mode option\n");
		return(0);
	}

	printf("Open target file %s ", name );
	fflush(stdout);

	if( fopen_s( &fp, name, "r" ) != 0 ){
		printf( "\nError:unable to opne target file\n");
		return(0);
	}
	printf( "OK! \n");
	fflush(stdout);

	printf("Read hex file %s ", name );
	fflush(stdout);
	wSize = (WORD)ConvertIntelHexFormat( fp, wCode  );
	fclose(fp);

	if( wSize==-1 ) return(0);
	
	printf("OK\n");
	fflush(stdout);

	wCode[0] = 0x7000;	// reset vector̕ύX boot	ɔ
	wCode[1] = 0x0004;


	printf("Open target device:ID %d ", bID );
	fflush(stdout);
	if(!ScDevice.Open( bID, bMode, bChildID ) ){
		printf("Error:%s\n", ScDevice.Error );
		return(0);
	}
	printf("OK\n");
	fflush(stdout);

/**/
	printf("Erasing program memory ");
	fflush(stdout);

	if(!EraseCode( wSize )){
		printf("Error:%s\n",ScDevice.Error );
		ScDevice.Close();
		return(0);
	}

	printf("OK\n");
	fflush(stdout);

/**/
	printf("Writing new program ");
	fflush(stdout);

	if(!WriteCode( wCode, wSize )){
		printf("Error: %s\n",ScDevice.Error );
		ScDevice.Close();
		return(0);
	}

	printf("OK\n");
	fflush(stdout);

/**/
	printf("Reading program memory ");
	fflush(stdout);

	if(!ReadCode( wCode_v, wSize )){
		printf("Error: %s\n",ScDevice.Error );
		return(0);
	}

	printf("OK\n");
	fflush(stdout);

/**/
	printf("Verifying program code ");
	fflush(stdout);

	if(!VerifyingCode( wCode, wCode_v, wSize )){
		ScDevice.Close();
		return(0);
	}

	printf("OK\n");
	fflush(stdout);

/**/
	printf("Programming succeeded\n");

	printf("Run new program!\n");
	fflush(stdout);
	ScDevice.putb( RTSP_RUN );
	ScDevice.Close();

	return(1);
}

